
/*
 RandomTrade-4
:
1.            .
2.   SL  TP  .    (.3  4):
3.   SL     .
4.   TP     .
5.             OpRandPeriod .
6.          ClRandPeriod .
   .
*/

extern int Balk=1; //   
extern int SL=50; //  -
extern int TP=0; //  -
extern int OpRandPeriod=30; //         
extern int ClRandPeriod=300; //        

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   MathSrand(GetTickCount());
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
double cpl=0, cmn=0, dpl=0, dmn=0, lpl=0, lmn=0; 
int i=OrdersHistoryTotal()-1;
  while (i>=0 && OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)) {
    if (OrderProfit()>0) {
      cpl++;
      dpl=dpl+(OrderCloseTime()-OrderOpenTime());
      if (OrderType()==OP_BUY)
        lpl=lpl+(OrderOpenPrice()-OrderStopLoss());
      if (OrderType()==OP_SELL)
        lpl=lpl+(-OrderOpenPrice()+OrderStopLoss());
    } else {
      cmn++;
      dmn=dmn+(OrderCloseTime()-OrderOpenTime());
      if (OrderType()==OP_BUY)
        lmn=lmn+(OrderOpenPrice()-OrderStopLoss());
      if (OrderType()==OP_SELL)
        lmn=lmn+(-OrderOpenPrice()+OrderStopLoss());
    }
    i--;
  } 
  Print("   : "+DoubleToStr(lpl/cpl,4));
  Print("   : "+DoubleToStr(lmn/cmn,4));
  Print("     .: "+DoubleToStr(dpl/cpl/60/60,2));
  Print("     .: "+DoubleToStr(dmn/cmn/60/60,2));
  Print("  : "+DoubleToStr(cpl,0));
  Print("  : "+DoubleToStr(cmn,0));

//----
   MathSrand( GetTickCount());   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//|   ,                      |
//+------------------------------------------------------------------+
int GetOrder()
  {
int op=MathRand()/5461.4, dir=0;
double StopLoss=SL, TakeProfit=TP, price, sdvig=0;
   sdvig=MathRand()/300;
   if (sdvig<MarketInfo(Symbol(),MODE_STOPLEVEL)+1) sdvig=MarketInfo(Symbol(),MODE_STOPLEVEL)+1;
   switch(op) {
     case OP_BUY: price=Ask; dir=1; break;
     case OP_BUYLIMIT: price=Ask-sdvig*Point;  dir=1; break;
     case OP_BUYSTOP: price=Ask+sdvig*Point;  dir=1; break;
     case OP_SELL: price=Bid;  dir=-1; break;
     case OP_SELLLIMIT: price=Bid+sdvig*Point;  dir=-1; break;
     case OP_SELLSTOP: price=Bid-sdvig*Point;  dir=-1; break;
   }  
   if (TakeProfit>0) {
     TakeProfit=MathRand()/300;
     if (TakeProfit<MarketInfo(Symbol(),MODE_STOPLEVEL)+1) TakeProfit=MarketInfo(Symbol(),MODE_STOPLEVEL)+1;
     TakeProfit=price+dir*TakeProfit*Point;
   }  
   if (StopLoss>0) {
     StopLoss=MathRand()/300;
     if (StopLoss<MarketInfo(Symbol(),MODE_STOPLEVEL)+1) StopLoss=MarketInfo(Symbol(),MODE_STOPLEVEL)+1;
     StopLoss=price-dir*StopLoss*Point;
   }  
   return(OrderSend(Symbol(),op,0.1,NormalizeDouble(price, Digits),3
      ,NormalizeDouble(StopLoss, Digits)
      ,NormalizeDouble(TakeProfit, Digits)
      ,"",op,0));
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
static datetime prevtime=0;
if (Time[0]==prevtime) return(0);
  prevtime=Time[0];

//  if(Volume[0]>1) return(0); 
  int ticket, RandCl;

  for(int i=OrdersTotal()-1;i>=0;i--)
     {
      RandCl=MathRand()*ClRandPeriod/32768; //     [0;ClRandPeriod)
      if (!OrderSelect(i,SELECT_BY_POS,MODE_TRADES)) {Print("O    #",GetLastError()); continue;}
      if (OrderSymbol()!=Symbol()) continue;
      if (RandCl !=0) continue;
      if (OrderType()==0) OrderClose(OrderTicket(),0.1,Bid,3,Blue);
      if (OrderType()==1) OrderClose(OrderTicket(),0.1,Ask,3,Red);
     }
  
  int RandOp=MathRand()*OpRandPeriod/32768; //     [0;OpRandPeriod)
  if (RandOp==0) ticket=GetOrder();

   return(0);
  }
//+------------------------------------------------------------------+



